/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <worldvu/vu.h>
#include <worldvu/ext.h>
#include <string.h>
#include <unistd.h>

int add_bookmark(char *bookmark)
{
    char    path[128];
    FILE    *sp;

    snprintf(path, sizeof(path), "%s/.bookmark", getenv("HOME"));
    sp = fopen(path, "r+");
    if(sp) {
        for(;;) {
            fgets(path, sizeof(path) - 1, sp);
            if(feof(sp))
                break;

            if(!strcmp(bookmark, path))
                return -1;
        }
        fseek(sp, 0l, SEEK_END);
    }
    else
        sp = fopen(path, "w");

    if(!sp)
        return -1;

    fputs(bookmark, sp);
    fclose(sp);
    return 0;
}

