/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Standard diskette formatting table and window resources.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/disks.h>

FDFORMAT fd_fmttab[] =
{
    {{""}, {"5.25\" double sided 360 kilobytes"}, 2, 2, 40, 9, 512, -1},
    {{""}, {"5.25\" high density 1.2 megabytes"}, 2, 2, 80,15, 512, -1},
    {{""}, {"3.50\" double sided 720 kilobytes"}, 2, 2, 80, 9, 512, -1},
    {{""}, {"3.50\" high density 1.4 megabytes"}, 2, 2, 80,18, 512, -1}
};

int fd_fmtcnt = sizeof(fd_fmttab) / sizeof(FDFORMAT);
char fd_fmt_title[] = "Format diskette";
char fd_fmt_text[80];
char fd_fmt_format[] = "Format disk drive %s as\n%s";

/*
DEFWINDOW(VUFormatDisk)
    WIN_CLASS(VUFormatDiskPort, fd_fmt_title)
    WIN_ATTR(12, 40, HASMENUBAR | HASBORDER | HASSHADOW, 24, "Press <ESCAPE> to cancel")

    BAR_CONTROL(6, 2, 32, VU_BAR)
    TEXT_CONTROL(fd_fmt_text, 2, 2, 2, 36, 0)

    BUTTON_CONTROL(" ~Accept ",9, 4, 8, VU_ACCEPT)
    BUTTON_CONTROL(" ~Cancel ",9,28, 8, VU_CANCEL)
ENDDEF
*/
