/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <worldvu/vu.h>
#include <worldvu/ext.h>
#include <string.h>

char *strint(int i, int z)
{
    static  char buf[16];
    char    b1[16];
    char    *p = buf, *q = b1;
    unsigned u;

    if(!i) {
	if(z < 1)
	    z = 1;
	while(z--)
	    *(p++) = '0';
	*p = 0;
	return buf;
    }
    if((i < 0) && !z) {
	i = -i;
	buf[0] = '-';
	++p;
    }
    u = (unsigned)i;

    while(u > 0) {	
	*(q++) = (char)(u % 10) + '0';
	u /= 10;
    }
    *q = 0;
    z -= strlen(b1);
    while(z-- > 0)
	*(p++) = '0';
    
    while(q > b1)
	*(p++) = *(--q);
    *p = 0;
    return buf;
}
	
	

