/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>

DEFCONTROL(VUBarControl)
{
    CELL    cell = 0x300;
    int     row=control->crow + vu->vudrawn.tp;
    int     col=control->ccol + vu->vudrawn.lt;
    int     percent = control->cstate;
    int     pos = 0;
    int     change = control->cwid;
    char    digits[5];
    char    *p = digits;
    int     pbegin, plen;
    int     width = change - 2;

    switch(event) {
    case VU_CREATE:
        return TRUE;

    case VU_PAINT:
        VUDrawBox(row, col, control->clen, control->cwid);
        strcpy(digits, "0%");
        if(percent >= 100) {
            strcpy(digits, "100%");
            change = 0;
        }
        else if(percent > 0) {
            change = (width * percent) / 100;
            if(percent >= 10)
                *(p++) = (char)(percent / 10 + '0');
            *(p++) = (char)(percent % 10 + '0');
            *(p++) = '%';
            *p = 0;
        }
        plen = strlen(digits);
        pbegin = (width - plen) / 2;

        ++row;
        ++col;
        while(pos < width) {
            if(pos > change)
                cell = 0x0600;

            if((pos < pbegin) || (pos >= (pbegin + plen)))
                VUDrawCell(cell | ' ', row, col++);
            else
                VUDrawCell(cell | (CELL)digits[pos - pbegin], row, col++);
            ++pos;
        }
    default:
        return FALSE;
    }
}
