/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * This control can be used to draw a box around a group of related
 * controls.  Derived from text control.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/multi.h>

DEFCONTROL(VUBoxControl)
{
    char    *p;
    int     row,col,erow,ecol;
    CELL    cell=(vu->vupal << 8);
    int     r,c;

    if(event==VU_PAINT) {
        p = (char *)VUTextCtrlString(control->ctext);
        row  = control->crow + vu->vudrawn.tp;
        col  = control->ccol + vu->vudrawn.lt;
        erow = control->crow + vu->vudrawn.tp + control->clen -1;
        ecol = control->ccol + vu->vudrawn.lt + control->cwid -1;
        cell = (CELL)((vu->vupal + control->cstate) << 8) + 0x0100 + SPECIAL;

        VUDrawCell(BOX_D | BOX_R | cell,row,col);
        VUDrawCell(BOX_D | BOX_L | cell,row,ecol);
        VUDrawCell(BOX_U | BOX_R | cell,erow,col);
        VUDrawCell(BOX_U | BOX_L | cell,erow,ecol);

        for(r=row + 1;r<erow;++r) {
            VUDrawCell(BOX_U | BOX_D | cell,r,col);
            VUDrawCell(BOX_U | BOX_D | cell,r,ecol);
        }

        for(c=col + 1;c<ecol;++c) {
            VUDrawCell(BOX_L | BOX_R | cell,row,c);
            VUDrawCell(BOX_L | BOX_R | cell,erow,c);
        }

        cell=(CELL)((vu->vupal + control->cstate )<< 8)+0x0100;
        if(p != NULL) {
            while(*p && col < ecol) {
                if(*p==VU_MARKER_CELL)
                    cell +=0x0100;
                else {
                    ++col;
                    VUDrawCell((CELL) *p | cell,row,col);
                    cell=(CELL)((vu->vupal + control->cstate )<< 8)+0x0100;
                }
                ++p;
            }
        }
        p2=TRUE;
    }
    return USECONTROL(VUTextControl);
}
