/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/multi.h>
#include <worldvu/keys.h>
#include <worldvu/edit.h>

const   DEFWINDOW(VUBrowseFile)
    WIN_CLASS(VUBrowseFilePad, (STRING)"File Viewer")
    WIN_ATTR(24, 80, HASBORDER | HASSHADOW | HASMENUBAR, 24,
        (STRING)"Press <ESCAPE> to exit")
#ifdef  BUILD_LOCALIZED
    REPLACE_ITALIAN((STRING)"Visualizzatore documento", (STRING)"premi <ESCAPE> per uscire")
    REPLACE_ROMANIAN((STRING)"Citire fisier", (STRING)"apasati <ESCAPE> pentru abandon")
    REPLACE_CZECH((STRING)"Prohlizec souboru", (STRING)"Pro ukonceni stisknete <ESC>")
#endif
ENDDEF

DEFPORT(VUBrowseFilePad)
{
    switch(event) {
    case VU_CREATE:

        vu->vudrawn.tp = 1;
        vu->vudrawn.bt = rows - 2;
        vu->vudrawn.lt = 0;
        vu->vudrawn.rt = cols - 1;
    default:
        break;
    }
    return USEPORT(VUViewFilePad);
}

