/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Standard button control for VU.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/keys.h>

DEFCONTROL(VUButtonControl)
{
    char    *p = (char *)control->ctext;
    int     ca = 0;
    int     row = control->crow;
    int     col = control->ccol;
    int     wid = control->cwid;
    int     active = FALSE;

    row +=vu->vudrawn.tp;
    col +=vu->vudrawn.lt;

    if(control==vu->vucontrol)
        active=TRUE;

    while(*p && *p != '~') {
        ++ca;
        ++p;
    }
    if(!*p)
        ca=0;

    switch(event) {
    case VU_PAINT:
        p2=FALSE;
        VUDrawButtonUp(control->ctext,row,col,wid,vu->vupal);
        if(active) {
            vu->vucurcol=control->ccol + ca;
            vu->vucurrow=control->crow;
            vu->vucurmode=1;
        }
        return TRUE;
    case VU_KEYBOARD:
        switch(p1) {
        case ' ':
            if(!active)
                return FALSE;
        case KEY_ENTER:
            if(!active) {
                VUControlCursor(vu,control,0,ca);
                vu->vucontrol=control;
                return TRUE;
            }
            VUPostEvent(vu,VU_BUTTON,control->ctag,FALSE);
            VUPressButton(control,vu);
            return TRUE;
        case KEY_PAGEUP:
        case KEY_PAGEDOWN:
        case KEY_UP:
        case KEY_DOWN:
        case KEY_LEFT:
        case KEY_RIGHT:
        case KEY_TAB:
            if(active)
                return FALSE;
            VUControlCursor(vu,control,0,ca);
            vu->vucontrol=control;
            return TRUE;
        default:
            if(*p=='~') {
                if(VUKeyMatch(*(++p),p1)) {
                    if(!active) {
                        vu->vucontrol=control;
                        VUControlCursor(vu,control,0,ca);
                    }
                    VUPostEvent(vu,VU_BUTTON,control->ctag,FALSE);
                    VUPressButton(control,vu);
                    return TRUE;
                }
            }
        }
        return FALSE;
    default:
        break;
    }
    return TRUE;
}
