/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Create 'cardfile' style window interface under VU.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/keys.h>

DEFPORT(VUCardPort)
{
    int rtn,i,s;
    CELL    cell=vu->vupal << 8;
    char    *title=(char *)vu->vutitle;

    switch(event) {
    case VU_CREATE:
        if(VUGetAttr(vu,HASTITLE))
            VUClrAttr(vu,HASTITLE);
        if(VUGetAttr(vu,HASMENUBAR))
            VUClrAttr(vu,HASMENUBAR);
        break;
    case VU_KEYBOARD:
        if(p1 == KEY_ENTER) {
            if(!(rtn=USEPORT(VUFormPort)))
                VUPostEvent(vu,VU_DESTROY,KEY_ENTER,0);
            return TRUE;
        }
        break;
    case VU_PAINT:
        if(TRUE == (rtn=USEPORT(VUFormPort))) {
            if(*title) {
                s=vu->vudrawn.lt + ((vu->vudrawn.rt - vu->vudrawn.lt + 1) - strlen(title))/2;
                for(i=vu->vudrawn.lt;i<=vu->vudrawn.rt;++i)
                    if(i >= s && *title)
                        VUDrawCell((cell + 0x400) | ((CELL)*(title++)),vu->vudrawn.tp,i);
                    else
                        VUDrawCell(cell | ' ',vu->vudrawn.tp,i);
            }

            cell = (cell + 0x0600) | GRAPHIC_CELL | BOX_L | BOX_R;
            for(i=vu->vudrawn.lt;i<=vu->vudrawn.rt;++i)
                VUDrawCell(cell,vu->vudrawn.tp + 1,i);
        }
        return rtn;
    default:
        break;
    }
    return USEPORT(VUFormPort);
}

