/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Defines default system colors.
 */

#include <vu-config.h>
#include <worldvu/queue.h>

PALDEF  palette[64]=
{
    /* default color sets */

    { LIGHTGREY | BLACK, 0},        /* default shadow set */
    { DARKBLUE   | BLACK ,  0}, /* default application set */
    { LIGHTWHITE | BLACK, 0},       /* desktop title border */
    { DARKBLACK  | CYAN, 0},       /* select menubar text set and
                                        pull-down BORDER/interior */

    { INVERSE | DARKRED    | WHITE, 0},     /* highlight menubar text set */
    { INVERSE | DARKBLACK  | WHITE, 0},     /* standard menubar text set */
    { INVERSE | BLINK | DARKBLACK  | WHITE, 0},       /* menubar blink set */
    { DARKGREEN| BLACK, 0},                     /* standard desktop frame */

    /* pull-down menu and control coloring */

    {   DARKBLACK  | CYAN, 0},                  /* pull-down active */
    {   SUBBRIGHT | INVERSE | DARKRED | WHITE, 0},  /* pull-down hitkey */
    {   INVERSE | DARKBLACK | WHITE, 0},        /* inactive         */
    {   LIGHTGREY | WHITE, 0},                  /* unused field     */

    /* other control and color sets */

    /* list control uses verticle line to seperate item and controls */

    { INVERSE | DARKWHITE | BLACK, 0},          /* list control box */
    { BLACK | DARKBLACK, 0},                    /* desktop shadow */
    { INVERSE | LIGHTWHITE |CYAN, 0},                    /* active control button */
    { INVERSE | BRIGHT | SUBUNDERLINE |DARKRED|CYAN,0}, /* control button hit key */

    /* standard window class coloring (16) */

    { DARKBLACK  | WHITE, 0},               /* standard interior */
    { DARKBLUE   | WHITE, 0},               /* header/info block */
    { SUBINVERSE|BRIGHT |DARKRED    | WHITE, 0},        /* highlighted text in interior */
    { INVERSE |DARKBLACK  | CYAN, 0},       /* select field */

    { INVERSE | BRIGHT | LIGHTWHITE | GREEN, 0},       /* active menu bar */
    { INVERSE | DARKBLACK  | GREEN, 0},       /* inactive menu bar */
    { BRIGHT | LIGHTRED | WHITE, 0},       /* default border */
    { LIGHTGREY   | WHITE, 0},      /* inactive border */

    /* standard dialog class coloring (24) */

    { DARKBLACK| BLUE, 0},                  /* standard interior */
    { DARKWHITE | BLUE, 0},                 /* opt 1 - text */
    {SUBINVERSE|BRIGHT|DARKRED|BLUE,0},     /* warning text */
    {INVERSE | DARKBLACK | CYAN, 0},        /* opt 2 - edit field */

    { INVERSE | BRIGHT |LIGHTWHITE | GREEN, 0},    /* active menu bar */
    { INVERSE | DARKBLACK | GREEN, 0},       /* inactive menu bar */
    { BRIGHT | LIGHTYELLOW | BLUE, 0},          /* active border */
    { LIGHTGREY | BLUE, 0},                  /* inactive border */

    /* alert boxes and special box coloring (32) */

    { DARKBLACK | ORANGE, 0},                   /* standard interior */
    { DARKWHITE | ORANGE, 0},               /* opt 1 - text */
    {SUBINVERSE|BRIGHT|LIGHTRED|ORANGE,0},     /* warning text */
    {INVERSE | DARKBLACK | CYAN, 0},        /* opt 2 */

    { INVERSE | BRIGHT |LIGHTWHITE | RED, 0},    /* active menu bar */
    { INVERSE | DARKBLACK | RED, 0},       /* inactive menu bar */
    { BRIGHT | LIGHTYELLOW | ORANGE, 0},          /* active border */
    { LIGHTGREY | ORANGE, 0},                  /* inactive border */

    /*  notify boxes and special box coloring (40) */

    { DARKBLACK | GREEN, 0},
    { DARKWHITE | GREEN, 0},
    { SUBINVERSE | BRIGHT | LIGHTRED | GREEN,0},
    { INVERSE | DARKBLACK | CYAN, 0},

    {INVERSE | BRIGHT | LIGHTWHITE | MAGENTA, 0},
    {INVERSE | DARKBLACK | MAGENTA, 0},
    { BRIGHT | LIGHTYELLOW | GREEN, 0},
    { LIGHTGREY | GREEN,0 },

    /*  magenta info box coloring (48) */

    { DARKBLACK | MAGENTA, 0},
    { DARKWHITE | MAGENTA, 0},
    { SUBINVERSE | BRIGHT | LIGHTRED | MAGENTA,0},
    { INVERSE | DARKBLACK | CYAN, 0},

    {INVERSE | BRIGHT | LIGHTWHITE | GREEN, 0},
    {INVERSE | DARKBLACK | GREEN, 0},
    { BRIGHT | LIGHTYELLOW | MAGENTA, 0},
    { LIGHTGREY | MAGENTA,0 },

    /* card file box coloring (56) */

    { INVERSE | DARKBLACK  | WHITE, 0},             /* standard interior */
    { INVERSE | DARKBLUE   | WHITE, 0},             /* header/info block */
    { INVERSE | BRIGHT |DARKRED| WHITE, 0},     /* highlighted text in interior */
    {           DARKBLACK  | CYAN, 0},      /* select field */

    { INVERSE | BRIGHT | DARKMAGENTA | WHITE, 0},       /* active title bar */
    { INVERSE | DARKBLACK  | WHITE, 0},       /* inactive menu bar */
    { INVERSE | DARKRED | WHITE, 0},          /* default border */
    { INVERSE | LIGHTGREY   | WHITE, 0}     /* inactive border */
};
