/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/keys.h>

#define c   (control->ctext[control->cstate])

DEFCONTROL(VUEditMaskControl)
{
    switch(event) {
    case VU_CREATE:
        control->cwid = strlen((char *)control->ctext);
        if(!USECONTROL(VUEditLnControl))
            return FALSE;
        control->cstate = 0;
        while(!isdigit(c) && (c != '?') && (c != '*'))
            ++control->cstate;
        return TRUE;

    case VU_KEYBOARD:

        p2 = FALSE;

        if(p1 < 32 || p1 > 127) {
            if(p1 == KEY_DELETE)
                return FALSE;
            if(!USECONTROL(VUEditLnControl))
                return FALSE;

            switch(p1) {
            case KEY_RIGHT:
                if(!c)
                    return TRUE;
                while(!isdigit(c) && c != '?' && c != '*') {
                    ++control->cstate;
                    ++vu->vucurcol;
                }
                if(!c)
                    VUPostEvent(vu, VU_KEYBOARD, p1, 0);
                return TRUE;
            case KEY_LEFT:
                if(!control->cstate)
                    return TRUE;
                while(control->cstate && !isdigit(c) && c != '?' && c != '*') {
                    --control->cstate;
                    --vu->vucurcol;
                }
                if(!control->cstate)
                    VUPostEvent(vu, VU_KEYBOARD, p1, 0);
                return TRUE;
            }
            return TRUE;
        }

        if(isdigit(p1)) {
            while(c) {
                if(isdigit(c) || c == '?' || c == '*')
                    break;
                ++control->cstate;
                ++vu->vucurcol;
            }
            if(!c)
                return TRUE;
        }
        else
            return FALSE;

        if(!USECONTROL(VUEditLnControl))
            return FALSE;

        while(c) {
            if(isdigit(c) || (c == '?') || (c == '*'))
                break;
            ++control->cstate;
            ++vu->vucurcol;
        }
        if(!c)
            VUPostEvent(vu, VU_KEYBOARD, KEY_ENTER, 0);

        return TRUE;
    default:
        break;
    }
    return USECONTROL(VUEditLnControl);
}
