/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 *  Various little support utilities.
 */

#include <vu-config.h>
#include <worldvu/queue.h>
#include <worldvu/multi.h>

void VUTextSize(char *p,int *l, int *w)
{
    int maxl=1,maxw=1,wid=0;

    p = (char *)VUTextString((STRING)p);
    while(*p) {
        if(*p=='\n') {
            wid=0;
            ++maxl;
        }
        else if(++wid > maxw)
            maxw=wid;
        ++p;
    }
    *l=maxl;
    *w=maxw;
}

int VUKeyMatch(int k1, int k2)
{
    k1 &= 0xff;
    k2 &= 0xff;

    if(k1 > 96 && k1 < 128)
        k1 -= 32;

    if(k2 > 96 && k2 < 128)
        k2 -= 32;

    if(k1 < 32)
        k1= k1 + 64;

    if(k2 < 32)
        k2 = k2 + 64;

    if(k1==k2)
        return k1;
    else
        return 0;
}

void VUControlCursor(VU vu, CITEM *control, int row, int col)
{
    vu->vucurcol=control->ccol + col;
    vu->vucurrow=control->crow + row;
    vu->vucurmode=1;
    ++redraw;
}


