/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Process input forms and verify 'accept' button event.
 */

#include <vu-config.h>
#include <worldvu/vu.h>

DEFPORT(VUFormPort)
{
    CITEM   *control = vu->vucontrol;
    int     rtn;

    switch(event) {
    case VU_BUTTON:
        if(p1 == VU_ACCEPT) {
            control = vu->vucontrols;
            while(control->cproc) {
                if(control->cmsg) {
                    if(!(*(control->cproc))(vu,control, VU_ACCEPT, p1, FALSE)) {
                        vu->vustatcolor = DARKRED | BLACK;
                        VUTermAlert(1);
                        (*(control->cproc))(vu,control, VU_ENTER, p1, 0);
                        return FALSE;
                    }
                }
                ++control;
            }
        }
        break;
    case VU_CREATE:
        control = NULL;
    case VU_KEYBOARD:
        rtn = USEPORT(VUWindowPort);
        if(vu->vucontrol != control) {
            if(control)
                (*(control->cproc))(vu, control, VU_EXIT, p1, 0);
            if(vu->vucontrol->cproc)
                (*(vu->vucontrol->cproc))(vu, vu->vucontrol, VU_ENTER, p1, 0);
        }
        return rtn;
    default:
        break;
    }
    return USEPORT(VUWindowPort);
}

