/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Classes to support menubar operation.
*/

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/keys.h>

DEFPORT(VUMenubarPort)
{
    int rtn;
    CITEM   *last_item = vu->vucontrol;

    switch(event) {
    case VU_CREATE:
        if(VUGetAttr(vu,HASBORDER))
            vu->vudrawn.bt = vu->vudrawn.tp + 2;
        last_item = NULL;
        break;
    case VU_KEYBOARD:
        switch(p1) {

    /* throw away up-down to children */

        case KEY_UP:
            return FALSE;
        case KEY_DOWN:
            return FALSE;
        default:
            break;
        }
    default:
        break;
    }

    /* on any menu switch, activate item immediately */

    rtn=USEPORT(VUWindowPort);
    if(vu->vucontrol != last_item)
        (*(vu->vucontrol->cproc))(vu, vu->vucontrol, VU_KEYBOARD, KEY_ENTER, 0);
    return rtn;
}

