/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/multi.h>

int VULoadMsgText(char *id, char **msgs, int count)
{
    char    lang[65];
    char    *env;
    FILE    *fp;
    char    path[128];
    char    lbuf[2048];
    char    *p;
    int     c = 0;

    env = getenv("LANG");
    if(env)
        if(!*env)
            env = NULL;

    if(env) {
        strcpy(lang, env);
        env = strtok(lang, "._");
    }
    else
        env = "default";

    strcpy(path, PREFIX_DATADIR "/");
    strcat(path, env);
    strcat(path, "/");
    strcat(path, id);
    strcat(path, ".msg");

    if(NULL == (fp = fopen(path, "r"))) {
        strcpy(path, PREFIX_DATADIR "/default/");
        strcat(path, id);
        strcat(path, ".msg");
        if(NULL == (fp = fopen(path, "r")))
            return 0;
    }

    p = lbuf;
    while(c < count) {
        fgets(p, 256, fp);
        if(feof(fp)) {
            *p = 0;
            break;
        }
        VUTrimString(p, "", " \r\n\t!");

        if(*p == '#')
            continue;

        if(!strcmp(p, ".")) {
            *p = 0;
            *msgs = (char *)malloc((int)(p - lbuf) + 2);
            strcpy(*(msgs++), lbuf);
            p = lbuf;
            ++c;
            continue;
        }
        strcpy(p, (char *)VUTextString((STRING)p));
        p += strlen(p);

        /* single line message text */

        if(lbuf[0] == '$') {
            *msgs = (char *)malloc((int)(p - lbuf) + 1);
            strcpy(*(msgs++), lbuf + 1);
            p = lbuf;
            ++c;
        }
        else
            *(p++) = '\n';
    }
    if(c < count) {
        *msgs = (char *)malloc((int)(p - lbuf) + 2);
        strcpy(*msgs, lbuf);
        ++c;
    }
    fclose(fp);
    return c;
}

