/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Set palette entry and force redraw of unset cells.
 */

#include <vu-config.h>
#include <worldvu/vu.h>

void VUSetPalette(PAL id, ATTR val, PAL shadow)
{
    int r, c , mark, nid;
    int offset = rows * cols;

    palette[id].palattr = val;
    palette[id].palshadow = shadow;

    for(r = 0; r < rows; ++r) {
        mark = r * rows;
        nid = id * 256;
        for(c = 0; c < cols; ++c) {
            if((imageport[mark + c] & PALMASK_CELL) == nid)
                imageport[mark + offset + c] = 0;
            ++redraw;
        }
    }
}
