/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <ctype.h>

/*  Determine which standard string functions are
    missing from the runtime library.
*/

#ifdef  SCO
#define LOWER_UPPER
#define ICMP
#endif

#ifdef  LINUX
#define LOWER_UPPER
#define ICMP
#endif

#ifdef  QNX
#ifndef __ANSI__
#define LOWER_UPPER
#define ICMP
#endif
#endif

#ifdef  COHERENT        /*  Coherent MWC has no ANSI string functions   */
#define LOWER_UPPER
#define ICMP
#endif

#ifdef  LOWER_UPPER
char *strlwr(s)
char *s;
{
    register char *old;

    if(!s)
        return NULL;

    old = s;
    while(*s = (char)tolower(*s))
        ++s;
    return old;
}

char *strupr(s)
char *s;
{
    register    char    *old;

    if(!s)
        return NULL;

    old = s;
    while(*s = (char)toupper(*s))
        ++s;
    return old;
}
#endif

#ifdef  ICMP
int strnicmp(const char *s1, const char *s2, int n)
{
    register int t;

    while(n--) {
        if (t = tolower(*s1) - tolower(*s2))
            return  t;

        if (!*s1)
            return 0;

        ++s1;
        ++s2;
    }
    return 0;
}

int stricmp(const char *s1, const char *s2)
{
    register int t;

    while(*s1 && *s2) {
        if (t = tolower(*s1) - tolower(*s2))
            return  t;

        ++s1;
        ++s2;
    }
    return tolower(*s1) - tolower(*s2);
}
#endif

