/* Copyright (C) 1989-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/* obsolete code... */
#if (0)
#include <vu-config.h>
#include <timer.h>
#include <dev.h>
#include <signal.h>
#include <process.h>

#ifdef  FORWARD
#undef  FORWARD
#endif

#include <vu/vu.h>
#include <vu/keys.h>
#include <vu/term.h>

#ifndef __ANSI__
extern  char    *getenv();
#endif

#define ATTRIBUTES  (BRIGHT | INVERSE | UNDERLINE | BLINK)

typedef struct {
    int keycode;
    char    *keytext;
}   KEY;

RECT        viewport;
CELL        *imageport;
int         rows, cols;
int         alert_mode = 2;
BOOL        color = TRUE;
BOOL        insert_mode = TRUE;
BOOL        inverse_mode = FALSE;
BOOL        console_mode = FALSE;
BOOL        keyboard_timer = TRUE;
BOOL        force_update = FALSE;
unsigned    speed = 0xffff;
ATTR        attrmask = COLORATTRMASK;
CELL        deskpattern = 0x0020;
int         imageline[80];
BOOL        inhibit_escape = FALSE;
BOOL        shadow_button = TRUE;

static      unsigned char   cbuf[80];
static      int     cpos = 0;
static      unsigned char *eolmap;
static      char    statline[128] = "";
static      int     cc = -1, cr = -1;
static      ATTR    attr = 0x07, attr1 = 0x07;
static      ATTR    clrmask = 0x0000;
static      ATTR    tstmask = COLORATTRMASK;
static      int     ttyno;
static      TERMDEF *term;
static      unsigned char       fcolor = 0, bcolor = 0;
static      int     offset;
static      unsigned char       ansicolors[] = {0, 4, 2, 6, 1, 5, 3, 7};
static      int     max_match;
static      int     alt_base = 0;
static      BOOL    graphics_mode = FALSE;
static      BOOL    cursor_visible = TRUE;
static      ATTR    attributes = ATTRIBUTES;
static      BOOL    inverse_status = FALSE;

#ifdef  __ANSI__
static  unsigned    short   far *video = 0l;
static  unsigned    short   far *vidpos;
#else
static  unsigned    short   video = 0;
static  unsigned    short   *vidpos;
#endif
static  unsigned    short   vidattr=0x0700;

#define io_query()  char_waiting(stdin)
#define chk_flush() if(cpos > 64)   io_flush()

FORWARD void    io_putc PROTO((int code));
FORWARD int     io_getc PROTO((int flag));
FORWARD void    io_flush PROTO((void));
FORWARD void    io_puts PROTO((STRING s));
FORWARD void    vid_puts PROTO((STRING s));
FORWARD unsigned char set_color PROTO((unsigned char code));
FORWARD void    setattr PROTO((ATTR));
FORWARD void    grcell PROTO((int cell));
FORWARD int     match PROTO((char *s1, char *s2, int len));
FORWARD void    cursor_address PROTO((int pos));

#ifdef __ANSI__
#define vid_putc(c) *(vidpos++) = vidattr | (unsigned char)(c)
#else
#define vid_putc(c) @(vidpos++) = vidattr | c
#endif

static  void    io_putc(c)
int     c;
{
    cbuf[cpos++] = (unsigned char)c;
    if(cpos > 79)
        io_flush();
}

static  int io_getc(flag)
int     flag;
{
    int timer = 20;
    int keycode;

    if(!flag && !keyboard_timer)
        if(!io_query())
            return 0;

    if(flag)
        timer = 3;

    iotime_set(stdin, timer);
    keycode = getc(stdin);
    if(keycode == -1)
        return 0;

    iotime_can(stdin);
    if(!keycode)
        return 0xff;
    return keycode;
}

static  void    vid_puts(s)
char    *s;
{
    while(*s)
        vid_putc(*(s++));
}

static  void    io_puts(s)
char    *s;
{
    while(*s)
    {
        cbuf[cpos++] = *(s++);
        if(cpos > 79)
            io_flush();
    }
}

static  void    io_flush()
{
    if(cpos)
    {
        fput(cbuf, cpos, stdout);
        fflush(stdout);
    }
    cpos = 0;
}

static  unsigned char   set_color(code)
unsigned char       code;
{
    if(term->term_color_ansi)
        return ansicolors[code];
    else
        return code;
}

static  void    setattr(cattr)
ATTR    cattr;
{
    ATTR    cattr1;
    int     count = 0;
    unsigned    char    fore, back;
    unsigned    char    merge;
    BOOL    fixcolor = FALSE;

    if(cattr == attr1)
        return;

    attr1 = cattr;

    cattr &= attrmask;

    if(video)
    {

        if(color)
        {
            if(cattr & 0x08)
                cattr = (cattr & ~0x08) | BRIGHT;
            vidattr = cattr << 8;
        }
        else
        {
            if(cattr & UNDERLINE)
                vidattr = 0x0100;
            else if(cattr & INVERSE)
                vidattr = 0x7000;
            else
                vidattr = 0x0700;
        }

        if(cattr & BLINK)
            vidattr |= 0x8000;

        if(cattr & BRIGHT)
            vidattr |= 0x0800;

        return;
    }

    if(color)
    {
        if(cattr & 0x08)
            cattr = (cattr & ~0x08) | BRIGHT;
    }

    cattr1 = cattr;
    cattr &= tstmask;
    if(cattr != cattr1)
    {
        if(cattr & SUBUNDERLINE)
            cattr |= UNDERLINE;
        else if(cattr & SUBBRIGHT)
            cattr |= BRIGHT;
        else if(cattr & SUBINVERSE)
            cattr |= INVERSE;
    }
    cattr &= ~(SUBUNDERLINE | SUBINVERSE | SUBBRIGHT);
    if(cattr == attr)
        return;

    if(graphics_mode)
        if((attr & SPECIAL) != (cattr & SPECIAL))
        {
            if(cattr & SPECIAL)
                io_puts(term->term_attr_graphics_on);
            else
            {
                if(term->term_attr_graphics_off[0])
                    io_puts(term->term_attr_graphics_off);
                else if(term->term_attr_graphics_on[0])
                {
                    io_puts(term->term_attr_clear);
                    attr &= ~(clrmask | 0x77);
                    fixcolor = TRUE;
                }
            }
        }

    if((attr & attributes) != (cattr & attributes))
    {
        chk_flush();
        io_puts(term->term_attr_beg);
        if(term->term_attr_merge)
        {
            if(term->term_attr_beg[0])
            {
                merge = term->term_attr_clear[0];
                if(cattr & BRIGHT)
                    merge |= term->term_attr_bright_on[0];
                if(cattr & INVERSE)
                    merge |= term->term_attr_inverse_on[0];
                if(cattr & BLINK)
                    merge |= term->term_attr_blink_on[0];
                if(cattr & UNDERLINE)
                    merge |= term->term_attr_underline_on[0];
                io_putc(merge);
            }
        }
        else
        {
            if(attr & clrmask)
            {
                if((attr & clrmask) != (cattr & clrmask))
                {
                    attr &= ~(clrmask | 0x77);
                    fixcolor = TRUE;
                    io_puts(term->term_attr_clear);
                    ++count;
                }
            }

            if((attr & BRIGHT) != (cattr & BRIGHT))
            {
                if(count++)
                    io_puts(term->term_attr_sep);
                if(cattr & BRIGHT)
                    io_puts(term->term_attr_bright_on);
                else
                    io_puts(term->term_attr_bright_off);
            }

            if((attr & BLINK) != (cattr & BLINK))
            {
                if(count++)
                    io_puts(term->term_attr_sep);
                if(cattr & BLINK)
                    io_puts(term->term_attr_blink_on);
                else
                    io_puts(term->term_attr_blink_off);
            }

            if((attr & INVERSE) != (cattr & INVERSE))
            {
                if(count++)
                    io_puts(term->term_attr_sep);
                if(cattr & INVERSE)
                    io_puts(term->term_attr_inverse_on);
                else
                    io_puts(term->term_attr_inverse_off);
            }

            if((attr & UNDERLINE) != (cattr & UNDERLINE))
            {
                if(count++)
                    io_puts(term->term_attr_sep);
                if(cattr & UNDERLINE)
                    io_puts(term->term_attr_underline_on);
                else
                    io_puts(term->term_attr_underline_off);
            }
            if(term->term_color_attr)
            {
                if(fixcolor || ((cattr & 0x07) != (attr & 0x07)))
                {
                    fore = (unsigned char)(set_color((unsigned char)(cattr & 0x07)) + fcolor);
                    if(count++)
                        io_puts(term->term_attr_sep);
                    io_puts(term->term_color_beg);
                    io_putc(fore);
                }
                if(fixcolor || ((cattr & 0x70) != (attr & 0x70)))
                {
                    back = (unsigned char)(set_color((unsigned char)((cattr & 0x70) >> 4)) + bcolor);
                    if(count++)
                        io_puts(term->term_attr_sep);
                    io_puts(term->term_color_sep);
                    io_putc(back);
                }
            }
        }
        io_puts(term->term_attr_end);
    }

    if(color && !term->term_color_attr)
    {
        chk_flush();
        if((attr & 0x77) != (cattr & 0x77))
        {
            fore = (unsigned char)(set_color((unsigned char)(cattr & 0x07)) + fcolor);
            back = (unsigned char)(set_color((unsigned char)((cattr & 0x70) >> 4)) + bcolor);
            io_puts(term->term_color_beg);
            if(term->term_attr_merge)
            {
                if(term->term_color_order)
                    merge = (unsigned char)((unsigned char)(fore * 16) | (unsigned char)back | term->term_color_sep[0]);
                else
                    merge = (unsigned char)((unsigned char)(back * 16) | (unsigned char)fore | term->term_color_sep[0]);
                if(!term->term_attr_beg[0])
                {
                    if(cattr & BRIGHT)
                        merge |= term->term_attr_bright_on[0];
                    if(cattr & BLINK)
                        merge |= term->term_attr_blink_on[0];
                }
                io_putc(merge);
            }
            else if(term->term_color_order)
            {
                io_putc(fore);
                io_puts(term->term_color_sep);
                io_putc(back);
            }
            else
            {
                io_putc(back);
                io_puts(term->term_color_sep);
                io_putc(fore);
            }
            io_puts(term->term_color_end);
        }
    }
    attr = cattr;
}

static  void    grcell(cell)
int     cell;
{
    if(video)
    {
        if(cell < 16)
        {
            vid_putc(term->char_boxset[cell]);
            return;
        }

        switch(cell)
        {
        case ARROW_U:
        case ARROW_D:
        case ARROW_L:
        case ARROW_R:
            vid_putc(term->char_arrows[cell - ARROW_U]);
            return;

        case CARD_CLUBS:
        case CARD_HEARTS:
        case CARD_DIAMONDS:
        case CARD_SPADES:
            vid_putc(term->char_cards[cell - CARD_CLUBS]);
            return;

        case BOX_FILL_TOP:
            vid_putc(term->char_top);
            return;

        case BOX_FILL_BOT:
            vid_putc(term->char_bot);
            return;

        case BOX_SOLID:
            vid_putc(term->char_solid);
            return;

        case BOX_SHADED:
        default:
            vid_putc(term->char_shade);
            return;
        }
    }

    if(cell < 16)
    {
        io_putc(term->char_boxset[cell]);
        return;
    }

    switch(cell)
    {
    case ARROW_U:
    case ARROW_D:
    case ARROW_L:
    case ARROW_R:
        io_putc(term->char_arrows[cell - ARROW_U]);
        return;

    case CARD_CLUBS:
    case CARD_HEARTS:
    case CARD_DIAMONDS:
    case CARD_SPADES:
        io_putc(term->char_cards[cell - CARD_CLUBS]);
        return;

    case BOX_FILL_TOP:
        io_putc(term->char_top);
        return;

    case BOX_FILL_BOT:
        io_putc(term->char_bot);
        return;

    case BOX_SOLID:
        io_putc(term->char_solid);
        return;

    case BOX_SHADED:
    default:
        io_putc(term->char_shade);
        return;
    }
}

int     PASCAL  VUTermWrite(addr, len)
char    *addr;
int     len;
{
    io_flush();
    fput(addr, len, stdout);
    fflush(stdout);
    return len;
}

int     PASCAL  VUTermRead(addr, len, term)
char    *addr;
int     len;
char    *term;
{
    int     pos = 0;
    unsigned    char    c;
    char    *base = addr;

    while(pos < len)
    {
        if(0 == (c = (unsigned char)io_getc(pos)))
            return pos;
        *(addr++) = c;

        if(term)
        {
            *addr = 0;
            if(strpbrk(base, term))
                return pos;
        }
        ++pos;
    }
    return pos;
}

void    PASCAL  VUTermBlank()
{
    io_puts(term->term_cls);
    io_flush();
    while(!VUTermKey())
        ;
    VUForceRedraw();
}

void    PASCAL  VUTermAlert(mode)
int     mode;
{
    if(!mode)
        mode = alert_mode;

    while(mode--)
        io_puts(term->term_beep);

    io_flush();
}

static  void    cursor_address(pos)
int     pos;
{
    char    buf[4];
    char    *p = buf;

    pos += offset;

    if(term->term_cursor_decimal)
    {
        if(pos > 99)
        {
            *(p++) = (char)(pos / 100 + '0');
            pos %= 100;
        }
        if(pos > 9)
        {
            *(p++) = (char)(pos / 10 + '0');
            pos %= 10;
        }

        *(p++) = (char)(pos + '0');
        *p = 0;
        io_puts(buf);
    }
    else
        io_putc((unsigned char)(pos & 0xff));
}

void    PASCAL  cursor(r, c)
int     r, c;
{

    if(video)
    {
#ifdef  __ANSI__
        vidpos = video + r * cols + c;
#else
        vidpos = (unsigned short *)0 + r * cols + c;
#endif
        return;
    }

    if((r == cr) && (c == cc))
        return;

    chk_flush();
    if((r == cr) && (c == (cc - 1)))
        io_puts(term->term_left);
    else if((r == (cr + 1)) && (c == cc))
        io_puts(term->term_down);
    else if((r == cr) && (c == (cc + 1)) && term->term_right[0])
        io_puts(term->term_right);
    else if((r == (cr - 1)) && (c == cc) && term->term_up[0])
        io_puts(term->term_up);
    else if(!c && term->term_cursor_vt[0])
    {
        io_puts(term->term_cursor_beg);
        cursor_address(r);
        io_puts(term->term_cursor_vt);
    }
    else
    {
        io_puts(term->term_cursor_beg);
        if(term->term_cursor_order)
        {
            cursor_address(r);
            io_puts(term->term_cursor_sep);
            cursor_address(c);
        }
        else
        {
            cursor_address(c);
            io_puts(term->term_cursor_sep);
            cursor_address(r);
        }
        io_puts(term->term_cursor_end);
    }
    cr = r;
    cc = c;
}

void    PASCAL  statln(msg)
char    *msg;
{
    int     i;

    cursor(rows - 1, 0);
    setattr(DARKWHITE | BLACK);

    if(video)
    {
        for(i = 0; i < cols; ++i)
            vid_putc(' ');
        cursor(rows - 1, 0);
        vid_puts(msg);
    }
    else
    {
        chk_flush();
        io_puts(term->term_eol);
        io_puts(msg);
        io_flush();
    }
}

void    PASCAL  fixcursor()
{
    register    VU  vu = front;
    char    *stat;
    int     i;
    ATTR    attr;
    BOOL    hide = FALSE;
    int     r, c;

    if(vu == NULL)
        return;

    while(NULL == (stat=vu->vustatline))
    {
        if(NULL == (vu=vu->vunext))
            break;
    }

    if(NULL == vu)
    {
        attr=DARKWHITE | BLACK;
        stat="";
    }
    else
        attr=vu->vustatcolor;

    if(strcmp(stat, statline))
    {
        strcpy(statline, stat);
        cursor(rows - 1, 0);
        if(inverse_status)
        {
            if(attr == DARKWHITE | BLACK)
                attr = DARKBLACK | WHITE;
            else
                attr |= WHITE;
        }
        setattr(attr);
        if(video)
        {
            for(i = 0; i < cols; ++i)
                vid_putc(' ');
        }
        else if(term->term_stat_line[0])
            io_puts(term->term_stat_line);
        else if(term->term_wrap_flag)
        {
            for(i = 0; i < cols; ++i)
                io_putc(' ');
        }
        else
            io_puts(term->term_eol);

        if(statline[0])
        {
            cursor(rows -1, (cols - strlen(statline))/2);
            if(video)
                vid_puts(statline);
            else
                io_puts(statline);
        }
    }

    if(!front->vucurmode)
        hide = TRUE;

    r=front->vucurrow + front->vudrawn.tp;
    c=front->vucurcol + front->vudrawn.lt;
    if((c > viewport.rt) || (c < viewport.lt) || (r < viewport.tp) || (r > viewport.bt))
        hide = TRUE;

    if(!video)
    {
        chk_flush();
        if(hide)
        {
            if(cursor_visible)
            {
                cursor_visible = FALSE;
                io_puts(term->term_cursor_hide);
            }
        }
    }
    if(hide)
    {
        r = rows - 1;
        c = 0;
    }
    cursor(r, c);
    if(video)
    {
        io_putc(27);
        io_putc('Y');
        io_putc(r + 32);
        io_putc(c + 32);
    }
    else if(!hide && !cursor_visible)
    {
        io_puts(term->term_cursor_show);
        cursor_visible = TRUE;
    }
    io_flush();
}

static  int match(s1, s2, len)
char    *s1, *s2;
int     len;
{
    int pos = 0;

    if(!s2)
        return 1;

    while(pos < len)
    {
        if(*s1 != *s2)
        {
            if(max_match < pos)
                max_match = pos;

            return pos + 1;
        }
        ++s1;
        ++s2;
        ++pos;
    }
    if(!*s2)
        return 0;
    else
    {
        if(max_match < pos)
            max_match = pos;
        return pos + 1;
    }
}

int PASCAL  VUTermKey()
{
    static  int keytab[] = {KEY_HOME, KEY_END, KEY_PAGEUP, KEY_PAGEDOWN, KEY_INSERT, KEY_DELETE, KEY_HELP, KEY_FIND};
    static  int altkeys[26] = {30, 48, 46, 32, 18, 33, 34, 35, 23, 36, 37, 38, 50, 49, 24, 25, 16, 19, 31, 20, 22, 47, 17, 45, 21, 44};
    static  KEY ansi[] = {{KEY_LEFT, "\033OD"}, {KEY_LEFT, "\033[1D"}, {KEY_RIGHT, "\033OC"}, {KEY_RIGHT, "\033[1C"}, {KEY_UP, "\033OA"}, {KEY_UP, "\033[1A"}, {KEY_DOWN, "\033OB"}, {KEY_DOWN, "\033[1B"}};
    static  int move[] = {KEY_UP, KEY_DOWN, KEY_LEFT, KEY_RIGHT};

    unsigned char   kbuf[8];
    int     kpos = 0;
    int     i;
    int     code;

    max_match = 0;

    while(kpos < 8)
    {
        code = io_getc(kpos);

        if(alt_base && !kpos)
        {
            if(code >= alt_base && code < (alt_base + 26))
                return ALTKEY | (((code - alt_base) & 0x1f) + 'A');
        }
        if(!code)
        {
            if(kpos == 1)
                return kbuf[0];

            i = strlen(term->key_alt_prefix);
            if(i && (i < kpos))
                if(!strncmp(term->key_alt_prefix, kbuf, i))
                    return ALTKEY | (kbuf[i] - alt_base);

            return 0;
        }

        kbuf[kpos] = (unsigned char)code;
        ++kpos;

        if(!match(kbuf, term->key_alt_prefix, kpos))
            return ALTKEY | ((io_getc(kpos) & 0x1f) + 'A');

/*
        if(!match(kbuf, term->term_left, kpos))
            return KEY_LEFT;

        if(!match(kbuf, term->term_right, kpos))
            return KEY_RIGHT;

        if(!match(kbuf, term->term_up, kpos))
            return KEY_UP;

        if(!match(kbuf, term->term_down, kpos))
            return KEY_DOWN;
*/

        for(i = 0; i < 10; ++i)
            if(!match(kbuf, term->key_table[i], kpos))
                return KEY_F1 + i;

        if(!match(kbuf, term->key_table[10], kpos))
            return 0x01;

        if(!match(kbuf, term->key_table[11], kpos))
            return 0x03;

        for(i = 0; i < 4; ++i)
            if(!match(kbuf, term->key_move[i], kpos))
                return move[i];

        for(i = 12; i < 20; ++i)
            if(!match(kbuf, term->key_table[i], kpos))
            {
                if(i == 16)
                {
                    if(insert_mode)
                        insert_mode = FALSE;
                    else
                        insert_mode = TRUE;
                    return 0;
                }
                return keytab[i - 12];
            }

        if(term->term_ansi_keypad)
            for(i = 0; i < (sizeof(ansi) / sizeof(KEY)); ++i)
            {
                if(!match(kbuf, ansi[i].keytext, kpos))
                    return ansi[i].keycode;
            }

        if(term->key_scancodes)
        {
            if((kpos == 1) && (code == 0xff) && !max_match)
                continue;

            if((kpos == 2) && (code == 224))
                continue;

            if(kbuf[0] == 0xff)
            {
                if(code > 58 && code < 69)
                    return KEY_F1 + code - 59;

                for(i = 0; i < 26; ++i)
                    if(altkeys[i] == code)
                        return ALTKEY + 'A' + i + 1;

                switch(code)
                {
                case 82:
                    if(insert_mode)
                        insert_mode = FALSE;
                    else
                        insert_mode = TRUE;
                    return 0;
                case 83:
                    return KEY_DELETE;
                case 71:
                    return KEY_HOME;
                case 79:
                    return KEY_END;
                case 73:
                    return KEY_PAGEUP;
                case 81:
                    return KEY_PAGEDOWN;
                case 72:
                    return KEY_UP;
                case 80:
                    return KEY_DOWN;
                case 75:
                    return KEY_LEFT;
                case 77:
                    return KEY_RIGHT;
                }
            }
        }

        if(kpos == 1 && !max_match)
            return kbuf[0];

        if(kpos > (max_match + 1))
            return 0;
    }
    return 0;
}

int PASCAL  VUTermUpdate()
{
    register    CELL    *mark;
    int c, r;
    BOOL        cflag;
    CELL        v;

    if(!force_update)
        if(VUTermPending())
            return 1;

    for(r = 0; r < rows - 1; ++r)
    {
        if(!imageline[r])
            continue;

        if(video)
        {
            *(eolmap + r) = (unsigned char)cols;
            continue;
        }
        else
            *(eolmap + r) = 0;

        mark = imageport + cols * r + cols;
        for(c = cols - 1;c > - 1;--c)
        {
            v = *(--mark) & 0x7fff;
            if((v != 0x0020) && (v != 0x0120))
            {
                *(eolmap + r)=(unsigned char)(++c);
                break;
            }
        }
    }

    if(video)
        if(video_tty(0) != ttyno)
        {
            sync_timer(2);
            return 1;
        }

    for(r = 0; r < rows - 1; ++r)
    {
        if(!imageline[r])
            continue;

        if(!force_update)
            if(VUTermPending())
            {
                if(!video)
                    io_flush();
                return 1;
            }

        mark = imageport + r * cols;
        imageline[r] = 0;
        cflag = TRUE;

/*
        if(!video)
        {
            if(cursor_visible)
                io_puts(term->term_cursor_hide);
            cursor_visible = FALSE;
        }
*/

        for(c = 0; c < cols; ++c)
        {
            if(*mark & REFRESH_CELL)
            {
                *mark &= ~REFRESH_CELL;
                if(cflag)
                {
                    cursor(r, c);
                    cflag = FALSE;
                }

                if(*(eolmap + r) <= c)
                {
                    setattr(DARKWHITE | BLACK);
                    io_puts(term->term_eol);
                    while(c++ < cols)
                        *(mark++) = deskpattern;
                    break;
                }

                if(*mark & GRAPHIC_CELL)
                {
                    setattr(palette[(*mark & 0x3f00) >> 8].palattr | SPECIAL);
                    grcell(*mark & 0xff);
                }
                else
                {
                    setattr(palette[(*mark & 0x3f00) >> 8].palattr);
                    if(video)
                        vid_putc(*mark & 0xff);
                    else
                        io_putc(*mark & 0xff);
                }
                ++cc;
            }
            else
                cflag = TRUE;
            ++mark;
        }
    }
    fixcursor();
    force_update = FALSE;
    return 0;
}

int PASCAL  VUTermPending()
{
    if(front != NULL)
    {
        if(VUGetAttr(front, BLOCKED))
        {
            while(io_query())
                io_getc(0);
            VUTermAlert(1);
            return 0;
        }
    }
    else
        return 0;

    return io_query();
}

int PASCAL  VUTermStartup()
{
    char    *env;
    FILE    *fp;
    struct  dev_entry   dev;
    unsigned    n;
    int     i;

    signal(SIGINT, SIG_IGN);

    if(NULL != ( fp = fopen("/config/colorset.cfg", "r")))
    {
        fread(palette,sizeof(PALDEF),64,fp);
        fclose(fp);
    }

    ttyno = fdevno(stdin);
    set_option(stdin, get_option(stdin) & ~(ECHO | EDIT | ERS));
    get_attr(stdin, &dev);
    if(!dev.tty_ESCAPE)
        ++inhibit_escape;

    if(dev.tty_type < 4)
    {
        console_mode = TRUE;
        n = video_get_size(fdevno(stdin));
        rows = (n >> 8) & 0xff;
        cols = n & 0xff;
        if(dev.tty_type==DEV_MONOCHROME)
            color = FALSE;

#ifdef  __ANSI__
        video = (unsigned short far *)((long)dev.tty_ioport * 0x10000l);
#else
        video = dev.tty_ioport;
        set_extra_segment(video);
#endif
        if(NULL == (term = LoadVUTermlib("qnx2")))
            return 0;
        putenv("TERM=qnx");
        inverse_status = TRUE;
    }
    else
    {
        env = getenv("BAUD");
        if(env)
            speed = atoi(env);

        env = getenv("TERM");
        if(!env)
        {
            env = "ansipc";
            putenv("TERM=ansipc");
        }

        if(NULL == (term = LoadVUTermlib(AliasVUTermlib(env))))
            return 0;

        rows = atoi(term->term_rows);
        cols = atoi(term->term_cols);
        io_puts(term->term_startup);
        io_flush();
    }

    if(!term->term_color_beg[0])
        color = FALSE;

    if(speed < 1200)
        color = FALSE;

    viewport.tp = 0;
    viewport.lt = 0;
    viewport.rt = cols - 1;
    viewport.bt = rows - 2;
    eolmap = (unsigned char *)malloc(rows);
    if(NULL == (imageport = (CELL *)malloc(rows * cols * sizeof(CELL))))
        return 0;

    for(i = 0; i < rows * cols; ++i)
        *(imageport + i) = 0x0000;          /* initialize in shadow */

    for(i = 0; i < rows; ++i)
        ++imageline[i];

    if(color || term->term_attr_inverse_on[0])
        inverse_mode = TRUE;

    if(!color)
        attrmask = MONOATTRMASK;

    if(!term->term_attr_blink_on[0])
        attrmask &= ~BLINK;

    if(!term->term_attr_inverse_on[0])
        attrmask &= ~SUBINVERSE;

    if(!term->term_attr_bright_on[0])
        attrmask &= ~SUBBRIGHT;

    if(!term->term_attr_underline_on[0])
        attrmask &= ~SUBUNDERLINE;

    alt_base = atoi(term->key_alt_base);
    offset = atoi(term->term_cursor_offset);
    fcolor = (unsigned char)atoi(term->term_color_fore);
    bcolor = (unsigned char)atoi(term->term_color_back);
    if(term->char_shade)
        deskpattern = 0x0100 | GRAPHIC_CELL | BOX_SHADED;

    if(!term->term_attr_merge)
    {
        if(!term->term_attr_bright_off[0])
            clrmask |= BRIGHT;

        if(!term->term_attr_inverse_off[0])
            clrmask |= INVERSE;

        if(!term->term_attr_underline_off[0])
            clrmask |= UNDERLINE;

        if(!term->term_attr_blink_off[0])
            clrmask |= BLINK;
    }

    if(term->term_attr_graphics_on[0])
        graphics_mode = TRUE;

    tstmask = attrmask | BRIGHT;
    if(!term->term_attr_inverse_on[0])
        tstmask &= ~INVERSE;

    if(!term->term_attr_bright_on[0])
        tstmask &= ~BRIGHT;

    if(!term->term_attr_underline_on[0])
        tstmask &= ~UNDERLINE;

    if(term->term_color_attr)
        attributes |= 0x77;

    if(term->term_stat_line[0] || term->term_wrap_flag)
        inverse_status = TRUE;

    if(!color || !term->char_top)
        shadow_button = FALSE;

    return TRUE;
}


void    PASCAL VUTermShutdown()
{
    int i;

    setattr(DARKWHITE | BLACK);
    cursor(rows - 1, 0);
    if(video)
    {
        io_putc(27);
        io_putc('Y');
        io_putc(32 + rows - 1);
        io_putc(32);
        for(i = 0; i < cols; ++i)
            vid_putc(' ');
    }
    else
    {
        io_puts(term->term_cursor_show);
        io_puts(term->term_eol);
        io_puts(term->term_shutdown);
    }
    io_flush();
    free(imageport);
    free(eolmap);
}

void sync_timer(int tics)
{
    set_timer(TIMER_WAKEUP, RELATIVE, 0l, tics, NULL);
}

#endif


