/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * A text resource control box
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/multi.h>

DEFCONTROL(VUTextControl)
{
    CITEM   *c1=control;

    char    *p=(char *)control->ctext;
    int     row,col,erow,ecol;
    CELL    cell;

    switch(event) {
    case VU_PAINT:

        if(!p2) {
            row  = control->crow + vu->vudrawn.tp;
            col  = control->ccol + vu->vudrawn.lt;
            erow = control->crow + vu->vudrawn.tp + control->clen;
            ecol = control->ccol + vu->vudrawn.lt + control->cwid;
            cell = (CELL)((vu->vupal + control->cstate) << 8);
            p = (char *)VUTextCtrlString((STRING)p);
            while(*p) {
                if(*p == '\n') {
                    if(++row >= erow)       /* if past last line, stop */
                        break;
                    col=control->ccol+vu->vudrawn.lt;
                }
                else if(*p == VU_MARKER_CELL && control->ctag)
                    cell += 0x0100;
                else if(col < ecol) {
                    VUDrawCell((CELL) *p | cell,row,col++);
                    cell=(CELL)((vu->vupal + control->cstate )<< 8);
                }
                ++p;
            }
        }
        if(vu->vucontrol == control) {
            control=vu->vucontrols;
            while(c1->cproc) {
                if(!c1->ctag)
                    ++c1;
                else
                    break;
            }
            if(c1->cproc) {
                while(control->cproc) {
                    if(control != c1) {
                        if(control->ctag == c1->ctag)
                            break;
                    }
                    ++control;
                }
                if(!control->cproc) {
                    control = c1;
                    if(!(++control)->cproc)
                        control=c1;
                }
                vu->vucontrol = control;
            }
        }
        return TRUE;
    case VU_KEYBOARD:
        if(!p)
            return FALSE;

        while(*p && *p != '~')
            ++p;

        if(*p == '~') {
            if(VUKeyMatch(*(++p), p1)) {
                control = vu->vucontrols;
                while(control->cproc) {
                    if(control != c1) {
                        if(control->ctag == c1->ctag)
                            break;
                    }
                    ++control;
                }
                if(!control->cproc)
                    return FALSE;

                vu->vucontrol = control;
                (*(control->cproc))(vu, control, VU_PAINT, 0, 0);   /* touch control */
                return TRUE;
            }
        }
        return FALSE;
    default:
        break;
    }
    return TRUE;
}
