/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Touch/update display for specific fields.
 */

#include <vu-config.h>
#include <worldvu/vu.h>

void VUTouchControl(VU vu, int tag)
{
    register    CITEM   *control=vu->vucontrols;
    int redraw=0;

    while(control->cproc) {
        if(control->ctag==tag) {
            if(!redraw && vu != front)
                VUToFront(vu);
            ++redraw;
            (*(control->cproc))(vu,control,VU_PAINT,0,0);
        }
        ++control;
    }
    if(redraw)
        ++redraw;
}

void VUActiveControl(VU vu, int tag)
{
    register    CITEM   *control=vu->vucontrols;

    if(vu->vucontrol->ctag==tag)
        return;

    while(control->cproc) {
        if(control->ctag==tag) {
            vu->vucontrol=control;
            if(vu==front) {
                (*(control->cproc))(vu,control,VU_PAINT,0,0);
                ++redraw;
            }
            return;
        }
        ++control;
    }
}

void VUSetControl(VU vu, int tag, int state)
{
    register    CITEM   *control=vu->vucontrols;

    while(control->cproc) {
        if(control->ctag==tag) {
            control->cstate=state;
            (*(control->cproc))(vu,control,VU_PAINT,0,0);
            ++redraw;
            return;
        }
        ++control;
    }
}

