/* Copyright (C) 1992-2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/term.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

static	unsigned	char	codepage[256];

static	void	eocp(fd, cp)
int	fd, cp;
{
	if(fd > -1 && cp > -1)
	{
		lseek(fd, (long)cp * sizeof(codepage), SEEK_SET);
		write(fd, codepage, sizeof(codepage));
		close(fd);
	}
}

int	main(argc, argv)
int	argc;
char	**argv;
{
	FILE	*fp;
	char	lbuf[128];
	char	path[65];
	int	fd = -1;
	int	cp = -1;
	int	i;
	int	v1;
	char	*p;

	if(argc != 2)
	{
		fputs("vucodepages: no spec file\n", stderr);
		exit(-1);
	}
	
	fp = fopen(argv[1], "r");
	if(!fp)
	{
		fputs("vucodepages: spec file missing\n", stderr);
		exit(-1);
	}
	
	for(;;)
	{
		fgets(lbuf, sizeof(lbuf) - 1, fp);
		if(feof(fp))
		{
			eocp(fd, cp);
			break;
		}				
		if(!isspace(lbuf[0]))
		{
			eocp(fd, cp);
			strcpy(path, PREFIX_CONFDIR "/codepages-");
			strcat(path, strtok(lbuf, " \t"));
			cp = atoi(strtok(NULL, "\n"));
			for(i = 0; i < 256; ++i)
				codepage[i] = i;
			fd = open(path, O_RDWR | O_CREAT, 0644);
			continue;
		}
		p = strtok(lbuf, " \t\n");
		if(!p)
			continue;
		
		if(!*p)
			continue;
			
		if(!isdigit(*p))
			continue;
			
		v1 = atoi(p);
		while(NULL != (p = strtok(NULL, " \t\n")))
			codepage[atoi(p)] = v1;	
	}
	fclose(fp);
	return 0;
}

		
