/* Copyright (C) 2014 David Sugar, Tycho Softworks.
 *
 * This file is part of worldvu.
 *
 * worldvu is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * worldvuvu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with worldvu.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vu-config.h>
#include <worldvu/vu.h>
#include <worldvu/term.h>
#include <stdio.h>
#include <string.h>

PROGRAM
{
	TERMDEF	term;
	FILE	*fp;
	char	*name;
	char	path[256];

	if(argc != 3)
	{
		fputs("use: vucopylib name newname\n", stderr);
		exit(-1);
	}

	name = argv[1];
	if(!strcmp(name, ".")) {
		snprintf(path, sizeof(path), "%s/.termdef", getenv("HOME"));
		name = path;
	}
	if(strchr(name, '/')) {
		fp = fopen(path, "r");
		if(!fp) {
			fprintf(stderr, "*** %s: unknown file\n", argv[1]);
			exit(-1);
		}
		fread(&term, sizeof(term), 1, fp);
		fclose(fp);
	}
	else {
		TERMDEF *t = LoadVUTermlib(name);
		if(!t) {
			fprintf(stderr, "*** %s: unknown terminal\n", argv[1]);
			exit(-1);
		}
		memcpy(&term, t, sizeof(term));
		CloseVUTermlib();
	}
	strcpy(term.term_id, argv[2]);
	SaveVUTermlib(&term);
	return 0;
}


